/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.aufgabe.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.aufgabe.entity.Aufgabe;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractAufgabeSearch {

  @Inject
  protected transient AufgabeExtendedDAO dao;

  public AbstractAufgabeSearch() {
    super();
  }

  public List<Aufgabe> getSearchResult(AufgabeSearchParameters searchParameters, EagerLoadingCollector<Aufgabe> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Aufgabe> querySearchResult(AufgabeSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
